package com.color.keyboard.black.adapter;


import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.color.keyboard.black.R;
import com.color.keyboard.black.bean.ChildData;
import com.color.keyboard.black.manager.Common;
import com.color.keyboard.black.myapi.OnCancelLikeApi;
import com.color.keyboard.black.activity.ApplyActivity;

import java.util.ArrayList;
import java.util.List;

public class AdapterLike extends RecyclerView.Adapter<AdapterLike.ForYouViewHolder> {

    private Context mContext;
    private List<ChildData> mList = new ArrayList<>();

    private OnCancelLikeApi mCallBack;

    public AdapterLike(Context context) {
        mContext = context;
    }

    public void setForYouList(List<ChildData> list) {
        this.mList = list;
        notifyDataSetChanged();
    }


    public void setRemoveLike(OnCancelLikeApi callback) {
        mCallBack = callback;
    }

    @NonNull
    @Override
    public ForYouViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        View view = LayoutInflater.from(mContext).inflate(R.layout.item_like, parent, false);
        return new ForYouViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ForYouViewHolder holder, int position) {
        ChildData childData = mList.get(position);
        String thumbGif = childData.getThumbGif();
        String thumb = childData.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            Common.INSTANCE.loadWepJif(mContext, thumbGif, holder.itemImg);
        } else {
            Glide.with(mContext).load(thumb)
                    .placeholder(R.drawable.im_placeholder)
                    .into(holder.itemImg);
        }
        holder.itemFavorite.setSelected(true);
        holder.layoutFavorite.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                holder.itemFavorite.setSelected(false);
                int adapterPosition = holder.getAdapterPosition();
                notifyItemRemoved(adapterPosition);
                if (mCallBack != null) {
                    mCallBack.onRemoveLike(childData);
                }
            }
        });
        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentApply = new Intent(mContext, ApplyActivity.class);
                intentApply.putExtra(ApplyActivity.SOURCE_KEY, childData);
//                intentApply.putExtra(ApplyActivity.DISPLAY_URL_KEY, childData.getImgPath());
//                intentApply.putExtra(ApplyActivity.ZIP_URL_KEY, childData.getZipPath());
//                intentApply.putExtra(ApplyActivity.NAME_KEY, childData.getTitleName());
//                intentApply.putExtra(ApplyActivity.GIF_KEY, childData.getImgGif());
                String intent_thumb;
                if (!thumbGif.isEmpty()) {
                    intent_thumb = thumbGif;
                } else {
                    intent_thumb = thumb;
                }
//                intentApply.putExtra(ApplyActivity.THUMB_KEY, intent_thumb);
                mContext.startActivity(intentApply);


            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public static class ForYouViewHolder extends RecyclerView.ViewHolder {

        private CardView cardView;
        private FrameLayout layoutFavorite;
        private ImageView itemImg, itemFavorite;

        public ForYouViewHolder(@NonNull View itemView) {
            super(itemView);
            cardView = itemView.findViewById(R.id.card_view);
            layoutFavorite = itemView.findViewById(R.id.layout_favorite);
            itemImg = itemView.findViewById(R.id.im);
            itemFavorite = itemView.findViewById(R.id.im_favorite);

        }

    }

}
